import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

#Data manipulering
#data.iloc[871,4]=0.0039

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]


#################

# PS, sections have to be ran individually
######################

# 60/40 vs futures
M=10000000
A = np.array([[1, round(np.corrcoef(exReturns["60/40"],exReturns["exfutucom"])[0][1],3)], [round(np.corrcoef(exReturns["60/40"],exReturns["exfutucom"])[0][1],3), 1]])
random_normal = np.random.multivariate_normal([0,0], A , size = M)



conditional = exReturns.copy()

for column in conditional:
    if (column == "date"):
        print("Dont standardize this")
    else: 
        mean = np.mean(conditional[column])
        std = np.std(conditional[column])
        conditional[column] = (conditional[column]-mean)/std


#####
#Results for table 4.6: Downside and upside correlations for theta equal zero (θ = 0)    
DownUp = pd.DataFrame(columns=['Downside', 'Upside', 'Difference', "Probabilty downside", "Probabilty upside" ])

for i in range(3):
    input_data = np.zeros(5)
    below1 = conditional[conditional.iloc[:,1]<0]
    below2 = below1[below1.iloc[:,i+3] < 0 ]
    input_data[0] = np.corrcoef(below2.iloc[:,1], below2.iloc[:,i+3])[0,1]
    
    above1 = conditional[conditional.iloc[:,1] > 0]
    above2 = above1[above1.iloc[:,i+3] > 0 ]
    input_data[1] = np.corrcoef(above2.iloc[:,1], above2.iloc[:,i+3])[0,1]
    input_data[2] = input_data[0]-input_data[1]
    input_data[3]  = len(below2) / len(conditional)
    input_data[4]  = len(above2) / len(conditional)
    DownUp.loc[conditional.columns[i+3]] = input_data

        

input_data = np.zeros(5)
below1 = conditional[conditional.iloc[:,3]<0]
below2 = below1[below1.iloc[:,4] < 0 ]
input_data[0] = np.corrcoef(below2.iloc[:,3], below2.iloc[:,4])[0,1]

above1 = conditional[conditional.iloc[:,3] > 0]
above2 = above1[above1.iloc[:,4] > 0 ]
input_data[1] = np.corrcoef(above2.iloc[:,3], above2.iloc[:,4])[0,1]
input_data[2] = input_data[0]-input_data[1]
input_data[3]  = len(below2) / len(conditional)
input_data[4]  = len(above2) / len(conditional)


DownUp.loc["Equilty_VS_bonds"] = input_data


DownUpLatex = DownUp.reset_index()
print(DownUpLatex.to_latex(index = False, multirow = True))


#### Conditional correlation from -1.5 standard deviation to 1.5 standandard deviation. According to equation for conditional downside and upside.
#Futurs vs equity
M=100000000
A = np.array([[1, round(np.corrcoef(exReturns["exequity"],exReturns["exfutucom"])[0][1],3)], [round(np.corrcoef(exReturns["exequity"],exReturns["exfutucom"])[0][1],3), 1]])
random_normal = np.random.multivariate_normal([0,0], A , size = M)

futucom_below = conditional[conditional["exfutucom"]<0]
futucom_equity_below = futucom_below[futucom_below["exequity"] < 0 ]

corr_futu_equity_below = np.corrcoef(futucom_equity_below["exfutucom"], futucom_equity_below["exequity"])

futucom_above = conditional[conditional["exfutucom"] > 0]
futucom_equity_above = futucom_above[futucom_above["exequity"] > 0 ]

corr_futu_equity_above = np.corrcoef(futucom_equity_above["exfutucom"], futucom_equity_above["exequity"])

corr_graph = np.zeros([32,2])
interval = np.zeros(32)
for i in range(31):
    tall = -1.5 + i*0.1
    if(tall <=0):
        
      
        futucom_below = conditional[conditional["exfutucom"]<tall]
        futucom_equity_below = futucom_below[futucom_below["exequity"] < tall ]
        
        
        futucom_equity_below = conditional[conditional["exfutucom"]<tall]
        
        
        
        corr_graph[i,1] = np.corrcoef(futucom_equity_below["exfutucom"], futucom_equity_below["exequity"])[1,0]
        print(len(futucom_equity_below["exfutucom"]))
        
        
       
        random_normal_below = random_normal[random_normal[:, 0] < tall]
        random_normal_below = random_normal_below[random_normal_below[:,1] < tall]
        
        
        
        corr_graph[i,0] = np.corrcoef(random_normal_below[:,0], random_normal_below[:,1])[1,0]
        interval[i] = tall
        
        
        
    else:
       
        futucom_above = conditional[conditional["exfutucom"] > tall]
        futucom_equity_above = futucom_above[futucom_above["exequity"] > tall ]
        
        futucom_equity_above = conditional[conditional["exfutucom"] > tall]
        
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above["exfutucom"], futucom_equity_above["exequity"])[1,0]
        print(len(futucom_equity_above["exfutucom"]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        #Et forsøk på at vi skal få to punkter, men dette blir ikke riktig nå, da vi bare overskriver
    
    if(tall == 0):
        futucom_above = conditional[conditional["exfutucom"] > tall]
        futucom_equity_above = futucom_above[futucom_above["exequity"] > tall ]
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above["exfutucom"], futucom_equity_above["exequity"])[1,0]
        print(len(futucom_equity_above["exfutucom"]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall

"""
Zero_point = 16
plt.plot(interval, corr_graph[:,0], color = "blue", label = "Normal distribution with 0.23 correlation")
plt.plot(interval[:Zero_point], corr_graph[:Zero_point,1], "o-" ,color = "red", label = "Condtional downside")
plt.plot(interval[Zero_point:], corr_graph[Zero_point:,1], "o-" ,color = "green", label = "Condtional upside")

plt.yticks(np.arange(0,0.6,0.1))
plt.axvline(0, color='black', linewidth=2)  # Vertical line at x=0
plt.xlabel("Standard deviation")
plt.ylabel("Correlation")
plt.legend(fontsize = 8)
plt.title("Condtional Correlation between Commodity futures and Equity")
plt.grid()
plt.show()
"""
################# Improved plot
# Set up a custom color palette
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'

#colors = ["#0072B2", "#D55E00", "#009E73"]  # Blue, Orange, Green
#colors = ["#0072B2", "#FF0000", "#009E73"]
colors =["#0072B2", "#B22222", "#2E8B57"]

# Create the plot
plt.figure(figsize=(8, 6))  # Set the figure size
plt.plot(interval, corr_graph[:, 0], color=colors[0], label="Normal Correlations", linewidth=2) # with full sample correlation of 0.23
plt.plot(interval[:16], corr_graph[:16, 1], "o-", color=colors[1], label="Observed Downside Correlations", markersize=8)
plt.plot(interval[16:], corr_graph[16:, 1], "o-", color=colors[2], label="Observed Upside Correlations", markersize=8)

# Set y-axis ticks and add a vertical line at x=0
plt.yticks(np.arange(0, 0.7, 0.1), fontsize=12)
plt.xticks( fontsize=12)

plt.axhline(0, color='black', linewidth=1)  # Horizontal line at y=0
plt.axvline(0, color='black', linewidth=1)  # Vertical line at x=0

# Add labels, title, and legend with increased font size
plt.xlabel("Threshold used to define return exceedances ", fontsize=16, fontfamily ="Times new roman")
plt.ylabel("Exceedance correlations", fontsize=16, fontfamily ="Times new roman")
plt.legend(fontsize=10, loc="upper left", prop={'family': 'Times New Roman', 'size':12})


# Add grid lines
plt.grid(True, linestyle='--', linewidth=0.5, color='gray')

# Set plot background color and spines color
plt.gca().set_facecolor('#F5F5F5')
plt.gca().spines['bottom'].set_color('gray')
plt.gca().spines['top'].set_color('gray')
plt.gca().spines['right'].set_color('gray')
plt.gca().spines['left'].set_color('gray')

# Set plot title and adjust plot spacing
plt.title("Correlation profile between Commodity Futures and Stocks", fontsize=20,fontfamily ="Times new roman")
#plt.subplots_adjust(left=0.12, right=0.92, bottom=0.1, top=0.9)

# Show the plot
plt.show()





####################################
###############################

# Futures vs 6040

M=100000000
A = np.array([[1, round(np.corrcoef(exReturns["60/40"],exReturns["exfutucom"])[0][1],3)], [round(np.corrcoef(exReturns["60/40"],exReturns["exfutucom"])[0][1],3), 1]])
random_normal = np.random.multivariate_normal([0,0], A , size = M)

asset1= "exfutucom"
asset2 = "60/40"


futucom_below = conditional[conditional[asset1]<0]
futucom_equity_below = futucom_below[futucom_below[asset2] < 0 ]

corr_futu_equity_below = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])

futucom_above = conditional[conditional[asset1] > 0]
futucom_equity_above = futucom_above[futucom_above[asset2] > 0 ]

corr_futu_equity_above = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])

corr_graph = np.zeros([32,2])
interval = np.zeros(32)
for i in range(31):
    tall = -1.5 + i*0.1
    if(tall <=0):
        
        futucom_below = conditional[conditional[asset1]<tall]
        futucom_equity_below = futucom_below[futucom_below[asset2] < tall ]
    
        corr_graph[i,1] = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])[1,0]
        print(len(futucom_equity_below[asset1]))
        
        random_normal_below = random_normal[random_normal[:, 0] < tall]
        random_normal_below = random_normal_below[random_normal_below[:,1] < tall]
        
        corr_graph[i,0] = np.corrcoef(random_normal_below[:,0], random_normal_below[:,1])[1,0]
        interval[i] = tall
        
        
        
    else:
        futucom_above = conditional[conditional[asset1] > tall]
        futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        #Et forsøk på at vi skal få to punkter, men dette blir ikke riktig nå, da vi bare overskriver
    
    if(tall == 0):
        futucom_above = conditional[conditional[asset1] > tall]
        futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        
Zero_point = 16
plt.plot(interval, corr_graph[:,0],  color = "blue", label = "Normal Correlations")
plt.plot(interval[:Zero_point], corr_graph[:Zero_point,1], "o-", color = "red", label = "Observed Downside Correlations")
plt.plot(interval[Zero_point:], corr_graph[Zero_point:,1], "o-", color = "green", label = "Observed Upside Correlations")

#plt.yticks(np.arange(0,0.6,0.1))
plt.axvline(0, color='black', linewidth=2)  # Vertical line at x=0
#plt.axhline(0, color='black', linewidth=2)  # Vertical line at x=0
plt.xlabel("Threshold used to define return exceedances")
plt.ylabel("Exceedance Correlations")
plt.legend(fontsize = 8)
plt.title("Correlation Profile between Commodity Futures and 60/40")
plt.show()

################# Improved plot
# Set up a custom color palette
colors = ["#0072B2", "#D55E00", "#009E73"]  # Blue, Orange, Green
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'

colors =["#0072B2", "#B22222", "#2E8B57"]


# Create the plot
plt.figure(figsize=(8, 6))  # Set the figure size
plt.plot(interval, corr_graph[:, 0], color=colors[0], label="Normal Correlations", linewidth=2) # with full sample correlation of 0.03
plt.plot(interval[:16], corr_graph[:16, 1], "o-", color=colors[1], label="Observed Downside Correlations", markersize=8)
plt.plot(interval[16:], corr_graph[16:, 1], "o-", color=colors[2], label="Observed Upside Correlations", markersize=8)

# Set y-axis ticks and add a vertical line at x=0
plt.yticks(np.arange(0, 0.7, 0.1), fontsize=16)
plt.xticks(fontsize = 16)

plt.axhline(0, color='black', linewidth=1)  # Horizontal line at y=0
plt.axvline(0, color='black', linewidth=1)  # Vertical line at x=0


# Add labels, title, and legend with increased font size
plt.xlabel("Threshold used to define return exceedances", fontsize=18, fontfamily ="Times new roman")
plt.ylabel("Exceedance Correlations", fontsize=18, fontfamily ="Times new roman")
plt.legend(fontsize=12, loc="upper left", prop={'family': 'Times New Roman', 'size':12})


# Add grid lines
plt.grid(True, linestyle='--', linewidth=0.5, color='gray')

# Set plot background color and spines color
plt.gca().set_facecolor('#F5F5F5')
plt.gca().spines['bottom'].set_color('gray')
plt.gca().spines['top'].set_color('gray')
plt.gca().spines['right'].set_color('gray')
plt.gca().spines['left'].set_color('gray')


# Set plot title and adjust plot spacing
plt.title("Correlation Profile Commodity Futures and 60/40", fontsize=22)
#plt.subplots_adjust(left=0.12, right=0.92, bottom=0.1, top=0.9)

# Show the plot
plt.show()





###############################
###########################

# Futures vs 60/40 based on 60/40 

asset1= "60/40"
asset2 = "exfutucom"

M=100000000
A = np.array([[1, round(np.corrcoef(exReturns[asset2],exReturns[asset1])[0][1],3)], [round(np.corrcoef(exReturns[asset2],exReturns[asset1])[0][1],3), 1]])
random_normal = np.random.multivariate_normal([0,0], A , size = M)


futucom_below = conditional[conditional[asset1]<0]
futucom_equity_below = futucom_below[futucom_below[asset2] < 0 ]

corr_futu_equity_below = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])

futucom_above = conditional[conditional[asset1] > 0]
futucom_equity_above = futucom_above[futucom_above[asset2] > 0 ]

corr_futu_equity_above = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])

points = int(42)

corr_graph = np.zeros([points,2])
interval = np.zeros(points)
for i in range(points-1):
    tall = -2 + i*0.1
    if(tall <=0):
        
        #futucom_below = conditional[conditional[asset1]<tall]
        #futucom_equity_below = futucom_below[futucom_below[asset2] < tall ]
        
        futucom_equity_below = conditional[conditional[asset1]<tall]
    
        corr_graph[i,1] = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])[1,0]
        print(len(futucom_equity_below[asset1]))
        
        random_normal_below = random_normal[random_normal[:, 0] < tall]
        #random_normal_below = random_normal_below[random_normal_below[:,1] < tall]
        
        corr_graph[i,0] = np.corrcoef(random_normal_below[:,0], random_normal_below[:,1])[1,0]
        interval[i] = tall
        
        
        
    else:
        #futucom_above = conditional[conditional[asset1] > tall]
        #futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        
        futucom_equity_above = conditional[conditional[asset1] > tall]
        
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        #random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        #Et forsøk på at vi skal få to punkter, men dette blir ikke riktig nå, da vi bare overskriver
    
    if(tall == 0):
        #futucom_above = conditional[conditional[asset1] > tall]
        #futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        
        futucom_equity_above = conditional[conditional[asset1] > tall]
        
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        #random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
 
 
################# Improved plot
# Set up a custom color palette

position = int(points/2)

colors = ["#0072B2", "#D55E00", "#009E73"]  # Blue, Orange, Green
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'

colors =["#0072B2", "#B22222", "#2E8B57"]

# Create the plot
plt.figure(figsize=(8, 6))  # Set the figure size
plt.plot(interval, corr_graph[:, 0], color=colors[0], label="Normal Correlations", linewidth=2) #full sample correlation of 0.21
plt.plot(interval[:position], corr_graph[:position, 1], "o-", color=colors[1], label="Observed Downside Correlations", markersize=8)
plt.plot(interval[position:], corr_graph[position:, 1], "o-", color=colors[2], label="Observed Upside Correlations", markersize=8)

# Set y-axis ticks and add a vertical line at x=0
plt.yticks(np.arange(0, 0.7, 0.1), fontsize=16)
plt.xticks(fontsize = 16)

plt.axhline(0, color='black', linewidth=1)  # Horizontal line at y=0
plt.axvline(0, color='black', linewidth=1)  # Vertical line at x=0

# Add labels, title, and legend with increased font size
plt.xlabel("Standard Deviation Tresholds from 60/40", fontsize=16)
plt.ylabel("Conditional Correlations", fontsize=18)
plt.legend(fontsize=12, loc="upper left")



# Add grid lines
plt.grid(True, linestyle='--', linewidth=0.5, color='gray')

# Set plot background color and spines color
plt.gca().set_facecolor('#F5F5F5')
plt.gca().spines['bottom'].set_color('gray')
plt.gca().spines['top'].set_color('gray')
plt.gca().spines['right'].set_color('gray')
plt.gca().spines['left'].set_color('gray')

# Set plot title and adjust plot spacing
plt.title("60/40 vs. Commodity Futures", fontsize=24)
#plt.subplots_adjust(left=0.12, right=0.92, bottom=0.1, top=0.9)

# Show the plot
plt.show()


####################################
#############################

# Futures vs 60/40 based on futures

asset1= "exfutucom"
asset2 = "60/40"

M=100000000
#A = np.array([[1, round(np.corrcoef(exReturns[asset2],exReturns[asset1])[0][1],3)], [round(np.corrcoef(exReturns[asset2],exReturns[asset1])[0][1],3), 1]])

A = np.corrcoef(exReturns[asset2],exReturns[asset1])
random_normal = np.random.multivariate_normal([0,0], A , size = M)


futucom_below = conditional[conditional[asset1]<0]
futucom_equity_below = futucom_below[futucom_below[asset2] < 0 ]

corr_futu_equity_below = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])

futucom_above = conditional[conditional[asset1] > 0]
futucom_equity_above = futucom_above[futucom_above[asset2] > 0 ]

corr_futu_equity_above = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])

points = int(42)

corr_graph = np.zeros([points,2])
interval = np.zeros(points)
for i in range(points-1):
    tall = -2 + i*0.1
    if(tall <=0):
        
        #futucom_below = conditional[conditional[asset1]<tall]
        #futucom_equity_below = futucom_below[futucom_below[asset2] < tall ]
        
        futucom_equity_below = conditional[conditional[asset1]<tall]
    
        corr_graph[i,1] = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])[1,0]
        print(len(futucom_equity_below[asset1]))
        
        random_normal_below = random_normal[random_normal[:, 0] < tall]
        #random_normal_below = random_normal_below[random_normal_below[:,1] < tall]
        
        corr_graph[i,0] = np.corrcoef(random_normal_below[:,0], random_normal_below[:,1])[1,0]
        interval[i] = tall
        
        
        
    else:
        #futucom_above = conditional[conditional[asset1] > tall]
        #futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        
        futucom_equity_above = conditional[conditional[asset1] > tall]
        
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        #random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        #Et forsøk på at vi skal få to punkter, men dette blir ikke riktig nå, da vi bare overskriver
    
    if(tall == 0):
        #futucom_above = conditional[conditional[asset1] > tall]
        #futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        
        futucom_equity_above = conditional[conditional[asset1] > tall]
        
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        #random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
 
 
################# Improved plot
# Set up a custom color palette

position = int(points/2)

colors = ["#0072B2", "#D55E00", "#009E73"]  # Blue, Orange, Green
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'

colors =["#0072B2", "#B22222", "#2E8B57"]


# Create the plot
plt.figure(figsize=(8, 6))  # Set the figure size
plt.plot(interval, corr_graph[:, 0], color=colors[0], label="Normal Correlations", linewidth=2) #with 0.21 correlation
plt.plot(interval[:position], corr_graph[:position, 1], "o-", color=colors[1], label="Observed Downside Correlations", markersize=8)
plt.plot(interval[position:], corr_graph[position:, 1], "o-", color=colors[2], label="Observed Upside Correlations", markersize=8)

# Set y-axis ticks and add a vertical line at x=0
plt.yticks(np.arange(0, 0.7, 0.1), fontsize=16)
plt.xticks(fontsize = 16)
plt.axhline(0, color='black', linewidth=1)  # Horizontal line at y=0
plt.axvline(0, color='black', linewidth=1)  # Vertical line at x=0

# Add labels, title, and legend with increased font size
plt.xlabel("Standard Deviation Tresholds from Commodity Futures", fontsize=16)
plt.ylabel("Conditional Correlations", fontsize=18)
plt.legend(fontsize=12, loc="upper right")

# Add grid lines
plt.grid(True, linestyle='--', linewidth=0.5, color='gray')

# Set plot background color and spines color
plt.gca().set_facecolor('#F5F5F5')
plt.gca().spines['bottom'].set_color('gray')
plt.gca().spines['top'].set_color('gray')
plt.gca().spines['right'].set_color('gray')
plt.gca().spines['left'].set_color('gray')

# Set plot title and adjust plot spacing
plt.title("Conditional Correlations Commodity Futures vs. 60/40", fontsize=24, fontfamily = "Times new roman")
#plt.subplots_adjust(left=0.12, right=0.92, bottom=0.1, top=0.9)

# Show the plot
plt.show()


#########################
######################

#stocks mot bonds

asset1= "exbond"
asset2 = "exfutucom"

M=100000000
A = np.array([[1, round(np.corrcoef(exReturns[asset1],exReturns[asset2])[0][1],3)], [round(np.corrcoef(exReturns[asset1],exReturns[asset2])[0][1],3), 1]])
random_normal = np.random.multivariate_normal([0,0], A , size = M)

futucom_below = conditional[conditional[asset1]<0]
futucom_equity_below = futucom_below[futucom_below[asset2] < 0 ]

corr_futu_equity_below = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])

futucom_above = conditional[conditional[asset1] > 0]
futucom_equity_above = futucom_above[futucom_above[asset2] > 0 ]

corr_futu_equity_above = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])

corr_graph = np.zeros([32,2])
interval = np.zeros(32)
for i in range(31):
    tall = -1.5 + i*0.1
    if(tall <=0):
        
        futucom_below = conditional[conditional[asset1]<tall]
        futucom_equity_below = futucom_below[futucom_below[asset2] < tall ]
    
        corr_graph[i,1] = np.corrcoef(futucom_equity_below[asset1], futucom_equity_below[asset2])[1,0]
        print(len(futucom_equity_below[asset1]))
        
        random_normal_below = random_normal[random_normal[:, 0] < tall]
        random_normal_below = random_normal_below[random_normal_below[:,1] < tall]
        
        corr_graph[i,0] = np.corrcoef(random_normal_below[:,0], random_normal_below[:,1])[1,0]
        interval[i] = tall
        
        
        
    else:
        futucom_above = conditional[conditional[asset1] > tall]
        futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
        #Et forsøk på at vi skal få to punkter, men dette blir ikke riktig nå, da vi bare overskriver
    
    if(tall == 0):
        futucom_above = conditional[conditional[asset1] > tall]
        futucom_equity_above = futucom_above[futucom_above[asset2] > tall ]
        corr_graph[i+1,1] = np.corrcoef(futucom_equity_above[asset1], futucom_equity_above[asset2])[1,0]
        print(len(futucom_equity_above[asset1]))
        
        random_normal_above = random_normal[random_normal[:,0] > tall]
        random_normal_above = random_normal_above[random_normal_above[:,1] > tall]
        
        corr_graph[i+1,0] = np.corrcoef(random_normal_above[:,0], random_normal_above[:,1])[1,0]
        interval[i+1] = tall
        
#####
#Results for table 4.7: Average excess correlations versus normal distribution
mean_down =  np.mean(corr_graph[:16, 1]-corr_graph[:16,0])
mean_up = np.mean(corr_graph[16:, 1]-corr_graph[16:,0])
    

"""
plt.plot(interval, corr_graph[:,0], color = "blue", label = "Normal distribution with 0.50 correlation")
plt.plot(interval[:16], corr_graph[:16,1],"o-", color = "red", label = "Conditional downside")
plt.plot(interval[16:], corr_graph[16:,1], "o-", color = "green", label = "Conditional upside")

plt.yticks(np.arange(0,0.6,0.1))
plt.axvline(0, color='black', linewidth=2)  # Vertical line at x=0
plt.xlabel("Standard deviation")
plt.ylabel("Correlation")
plt.legend(fontsize = 8, loc = "lower left")
plt.title("Condtional Correlation between Equity and Bonds")
plt.show()
"""

################# Improved plot
# Set up a custom color palette
colors = ["#0072B2", "#D55E00", "#009E73"]  # Blue, Orange, Green
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'
colors =["#0072B2", "#B22222", "#2E8B57"]

# Create the plot
plt.figure(figsize=(8, 6))  # Set the figure size
plt.plot(interval, corr_graph[:, 0], color=colors[0], label="Normal Correlations", linewidth=2) #with 0.29 correlation full sample 
plt.plot(interval[:16], corr_graph[:16, 1], "o-", color=colors[1], label="Observed Downside Correlations", markersize=8)
plt.plot(interval[16:], corr_graph[16:, 1], "o-", color=colors[2], label="Observed Upside Correlations", markersize=8)

# Set y-axis ticks and add a vertical line at x=0
plt.yticks(np.arange(0, 0.7, 0.1), fontsize=16)
plt.xticks(fontsize = 16)
plt.axhline(0, color='black', linewidth=1)  # Horizontal line at y=0
plt.axvline(0, color='black', linewidth=1)  # Vertical line at x=0

# Add labels, title, and legend with increased font size
plt.xlabel("Threshold used to define return exceedances", fontsize=18)
plt.ylabel("Exceedance Correlations", fontsize=18)
plt.legend(fontsize=12, loc="upper left")

# Add grid lines
plt.grid(True, linestyle='--', linewidth=0.5, color='gray')

# Set plot background color and spines color
plt.gca().set_facecolor('#F5F5F5')
plt.gca().spines['bottom'].set_color('gray')
plt.gca().spines['top'].set_color('gray')
plt.gca().spines['right'].set_color('gray')
plt.gca().spines['left'].set_color('gray')

# Set plot title and adjust plot spacing
plt.title("Correlation Profile Commodity Futures and Bonds", fontsize=22)
#plt.subplots_adjust(left=0.12, right=0.92, bottom=0.1, top=0.9)

# Show the plot
plt.show()
