

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])
data["int_yearly_change"] = -data.infYearly.shift(1)+data.infYearly



#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["aggbackcon"] = data["Aggregatebackcon"]
#exReturns["int_yearly_change"] = data["int_yearly_change"]

###
Indexes = exReturns.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1)

#årlig 
data_to_sort_aarlig = Indexes.iloc[12:,1:]/Indexes.iloc[:len(Indexes)-12,1:]

data_to_sort_aarlig = Indexes.iloc[12:,:].copy()
for i in range(len(data_to_sort_aarlig)):
    data_to_sort_aarlig.iloc[i,1:] = Indexes.iloc[i+12,1:]/Indexes.iloc[i,1:]-1
    

data_to_sort_aarlig["InfYearly"] = data.infYearly[12:]
data_to_sort_aarlig["int_yearly_change"] = data.int_yearly_change[12:]



#############################
# Quintiles på årlig returns overlapping i stedet for monthly. 

#Looking at descriptive of quintiles of infYearly 
data_to_sort_aarlig = data_to_sort_aarlig.join(data["infYearly"])
sort_inflation = data_to_sort_aarlig.sort_values("infYearly")
intervall = int(len(data_to_sort_aarlig)/5)
sort_inflation_stat_1 = sort_inflation[0:intervall].describe()

sort_inflation_stat_2 = sort_inflation[intervall:intervall*2].describe()

sort_inflation_stat_3 = sort_inflation[intervall*2:intervall*3].describe()

sort_inflation_stat_4 = sort_inflation[intervall*3:intervall*4].describe()

sort_inflation_stat_5 = sort_inflation[intervall*4:].describe()


table_inflation_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
table_inflation_quintile.loc["inflation mean"] = [sort_inflation_stat_1["infYearly"][1],sort_inflation_stat_2["infYearly"][1],sort_inflation_stat_3["infYearly"][1],sort_inflation_stat_4["infYearly"][1],sort_inflation_stat_5["infYearly"][1]]

sort_inflation_stat_1 = sort_inflation[0:intervall].describe()

sort_inflation_stat_2 = sort_inflation[intervall:intervall*2].describe()

sort_inflation_stat_3 = sort_inflation[intervall*2:intervall*3].describe()

sort_inflation_stat_4 = sort_inflation[intervall*3:intervall*4].describe()

sort_inflation_stat_5 = sort_inflation[intervall*4:].describe()



table_inflation_quintile.loc["60/40 mean"] = [sort_inflation_stat_1["60/40"][1],sort_inflation_stat_2["60/40"][1],sort_inflation_stat_3["60/40"][1],sort_inflation_stat_4["60/40"][1],sort_inflation_stat_5["60/40"][1]]

table_inflation_quintile.loc["exequity mean"] = [sort_inflation_stat_1["exequity"][1],sort_inflation_stat_2["exequity"][1],sort_inflation_stat_3["exequity"][1],sort_inflation_stat_4["exequity"][1],sort_inflation_stat_5["exequity"][1]]

table_inflation_quintile.loc["exbond mean"] = [sort_inflation_stat_1["exbond"][1],sort_inflation_stat_2["exbond"][1],sort_inflation_stat_3["exbond"][1],sort_inflation_stat_4["exbond"][1],sort_inflation_stat_5["exbond"][1]]

table_inflation_quintile.loc["exfutucom mean"] = [sort_inflation_stat_1["exfutucom"][1],sort_inflation_stat_2["exfutucom"][1],sort_inflation_stat_3["exfutucom"][1],sort_inflation_stat_4["exfutucom"][1],sort_inflation_stat_5["exfutucom"][1]]


## plot årlig

inflation_quintile_plot_årlig = table_inflation_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_årlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, inflation_quintile_plot_årlig['exfutucom mean'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, inflation_quintile_plot_årlig['60/40 mean'], width=bar_width, label='60/40 portfolio', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x, inflation_quintile_plot_årlig['exequity mean'], width=bar_width, label='Stock', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + bar_width, inflation_quintile_plot_årlig['exbond mean'], width=bar_width, label='Bond', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x + 2*bar_width, inflation_quintile_plot_årlig['inflation mean'], width=bar_width, label='Yearly Inflation mean level', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title
ax.set_xlabel('Quantiles', fontsize=12, fontweight='bold')
ax.set_ylabel('Mean Return', fontsize=12, fontweight='bold')
ax.set_title('Yearly Mean Return in Quantiles based on Yearly Inflation level', fontsize=14, fontweight='bold')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(inflation_quintile_plot_årlig.index, fontsize=10)

# Set the y-axis ticks and tick labels
ax.tick_params(axis='y', labelsize=10)

# Add a legend
ax.legend(fontsize=10)

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('inf_quantiles_YEARLYmean_return.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()


#lage latex tabell
table_inflation_quintile = table_inflation_quintile.mul(100).round(2).astype(str).add("%")
table_inflation_quintile.rename({"exfutucom mean":"Commodity futures", "exequity mean":"Stock", "exbond mean":"Bond"}, inplace = True)
table_inflation_quintile = table_inflation_quintile.reset_index()
print(table_inflation_quintile.to_latex(index = False, multirow = True))



################################################### Lag quantiler på årlig inflasjon for correlasjoner mellom assets åRLIG
infYearly_stat_1 = sort_inflation[0:intervall]

infYearly_stat_2 = sort_inflation[intervall:intervall*2]
infYearly_stat_3 = sort_inflation[intervall*2:intervall*3]

infYearly_stat_4 = sort_inflation[intervall*3:intervall*4]

infYearly_stat_5 = sort_inflation[intervall*4:]

corr_1 = infYearly_stat_1.corr()
corr_2 = infYearly_stat_2.corr()
corr_3 = infYearly_stat_3.corr()
corr_4 = infYearly_stat_4.corr()
corr_5 = infYearly_stat_5.corr()

corr_infYearly_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
corr_infYearly_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5'])


#corr_infYearly_quintile.loc["infMonth mean"] = [sort_inflation_stat_1["infMonth"][1],sort_inflation_stat_2["infMonth"][1],sort_inflation_stat_3["infMonth"][1],sort_inflation_stat_4["infMonth"][1],sort_inflation_stat_5["infMonth"][1]]
corr_infYearly_quintile.loc["60/40 vs Commodity futures"] = [corr_1["60/40"][0],corr_2["60/40"][0],corr_3["60/40"][0],corr_4["60/40"][0],corr_5["60/40"][0]]
corr_infYearly_quintile.loc["Stocks vs Bonds"] = [corr_1["exequity"][3],corr_2["exequity"][3],corr_3["exequity"][3],corr_4["exequity"][3],corr_5["exequity"][3]]

## plot

corr_quintile_plot_aarlig = corr_infYearly_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(corr_quintile_plot_aarlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']

colors = ['purple',  'orange', '#2874A6']
colors = ['#000066',  '#FFB74D', '#2874A6']

# Plot the bars for each asset with the appropriate color
ax.bar(x - bar_width, corr_quintile_plot_aarlig['60/40 vs Commodity futures'], width=bar_width, label='Commodity futures vs 60/40', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x , corr_quintile_plot_aarlig['Stocks vs Bonds'], width=bar_width, label='Stocks vs Bonds', edgecolor='black', linewidth=0.5, color=colors[1])


# Add labels and title
ax.set_xlabel('Quantiles', fontsize=18, fontfamily='Times New Roman')
ax.set_ylabel('Correlation', fontsize=20, fontfamily='Times New Roman')
ax.set_title('Conditional on Yearly Inflation', fontsize=24, fontfamily='Times New Roman')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(corr_quintile_plot_aarlig.index, fontsize=16, fontfamily='Times New Roman')

# Set the tick labels font
ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})

# Add a legend with Times New Roman font
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size':16})

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)
import matplotlib.ticker as ticker

# ...

# Set the y-axis ticks and tick labels with Times New Roman font and larger font size
ax.set_yticks(ax.get_yticks())
ax.set_yticklabels(ax.get_yticks(), fontsize=16, fontfamily='Times New Roman')

# Limit the number of decimal places in y-axis tick labels to two
ax.yaxis.set_major_formatter(ticker.FormatStrFormatter('%.2f'))
# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('corr_quantiles_infmean_YEARLYreturn.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()



# Quintiles på CHANGE i årlig inflasjon, årlig returns overlapping i stedet for monthly. 

#Looking at descriptive of quintiles of infYearly 
#data_to_sort_aarlig = data_to_sort_aarlig.join(data["infYearly"])
sort_inflation = data_to_sort_aarlig.sort_values("int_yearly_change")
intervall = int(len(data_to_sort_aarlig)/5)
sort_inflation_stat_1 = sort_inflation[0:intervall].describe()

sort_inflation_stat_2 = sort_inflation[intervall:intervall*2].describe()

sort_inflation_stat_3 = sort_inflation[intervall*2:intervall*3].describe()

sort_inflation_stat_4 = sort_inflation[intervall*3:intervall*4].describe()

sort_inflation_stat_5 = sort_inflation[intervall*4:].describe()


table_inflation_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
table_inflation_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5'])


table_inflation_quintile.loc["inflation mean"] = [sort_inflation_stat_1["int_yearly_change"][1],sort_inflation_stat_2["int_yearly_change"][1],sort_inflation_stat_3["int_yearly_change"][1],sort_inflation_stat_4["int_yearly_change"][1],sort_inflation_stat_5["int_yearly_change"][1]]

table_inflation_quintile.loc["60/40 mean"] = [sort_inflation_stat_1["60/40"][1],sort_inflation_stat_2["60/40"][1],sort_inflation_stat_3["60/40"][1],sort_inflation_stat_4["60/40"][1],sort_inflation_stat_5["60/40"][1]]

table_inflation_quintile.loc["exequity mean"] = [sort_inflation_stat_1["exequity"][1],sort_inflation_stat_2["exequity"][1],sort_inflation_stat_3["exequity"][1],sort_inflation_stat_4["exequity"][1],sort_inflation_stat_5["exequity"][1]]

table_inflation_quintile.loc["exbond mean"] = [sort_inflation_stat_1["exbond"][1],sort_inflation_stat_2["exbond"][1],sort_inflation_stat_3["exbond"][1],sort_inflation_stat_4["exbond"][1],sort_inflation_stat_5["exbond"][1]]

table_inflation_quintile.loc["exfutucom mean"] = [sort_inflation_stat_1["exfutucom"][1],sort_inflation_stat_2["exfutucom"][1],sort_inflation_stat_3["exfutucom"][1],sort_inflation_stat_4["exfutucom"][1],sort_inflation_stat_5["exfutucom"][1]]


## plot årlig

inflation_quintile_plot_årlig = table_inflation_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_årlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, inflation_quintile_plot_årlig['exfutucom mean'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, inflation_quintile_plot_årlig['60/40 mean'], width=bar_width, label='60/40 portfolio', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x, inflation_quintile_plot_årlig['exequity mean'], width=bar_width, label='Stock', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + bar_width, inflation_quintile_plot_årlig['exbond mean'], width=bar_width, label='Bond', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x + 2*bar_width, inflation_quintile_plot_årlig['inflation mean'], width=bar_width, label='Yearly Inflation change', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title
ax.set_xlabel('Quantiles', fontsize=12, fontweight='bold')
ax.set_ylabel('Mean Return', fontsize=12, fontweight='bold')
ax.set_title('Yearly Mean Return in Quantiles based on Yearly Inflation change', fontsize=14, fontweight='bold')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(inflation_quintile_plot_årlig.index, fontsize=10)

# Set the y-axis ticks and tick labels
ax.tick_params(axis='y', labelsize=10)

# Add a legend
ax.legend(fontsize=10)

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('inf_quantiles_YEARLYmean_return.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()


#lage latex tabell
table_inflation_quintile = table_inflation_quintile.mul(100).round(2).astype(str).add("%")
table_inflation_quintile.rename({"exfutucom mean":"Commodity futures", "exequity mean":"Stock", "exbond mean":"Bond"}, inplace = True)
table_inflation_quintile = table_inflation_quintile.reset_index()
print(table_inflation_quintile.to_latex(index = False, multirow = True))


############### CORRELATION QUANTILES

infYearly_stat_1 = sort_inflation[0:intervall]

infYearly_stat_2 = sort_inflation[intervall:intervall*2]
infYearly_stat_3 = sort_inflation[intervall*2:intervall*3]

infYearly_stat_4 = sort_inflation[intervall*3:intervall*4]

infYearly_stat_5 = sort_inflation[intervall*4:]

corr_1 = infYearly_stat_1.corr()
corr_2 = infYearly_stat_2.corr()
corr_3 = infYearly_stat_3.corr()
corr_4 = infYearly_stat_4.corr()
corr_5 = infYearly_stat_5.corr()

corr_infYearly_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
corr_infYearly_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5'])


#corr_infYearly_quintile.loc["infMonth mean"] = [sort_inflation_stat_1["infMonth"][1],sort_inflation_stat_2["infMonth"][1],sort_inflation_stat_3["infMonth"][1],sort_inflation_stat_4["infMonth"][1],sort_inflation_stat_5["infMonth"][1]]
corr_infYearly_quintile.loc["60/40 vs Commodity futures"] = [corr_1["60/40"][0],corr_2["60/40"][0],corr_3["60/40"][0],corr_4["60/40"][0],corr_5["60/40"][0]]
corr_infYearly_quintile.loc["Stocks vs Bonds"] = [corr_1["exequity"][3],corr_2["exequity"][3],corr_3["exequity"][3],corr_4["exequity"][3],corr_5["exequity"][3]]

## plot

corr_quintile_plot_aarlig = corr_infYearly_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(corr_quintile_plot_aarlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']
colors = ['#FFB3BA', '#FFDFBA', '#FFFFBA', '#Baffc9', '#BAE1FF']
colors = ['#CABAA5', '#E3CEB0', '#FFDCB0', '#D9D4A5', '#B0C0A1']
colors = ['purple',  '#3498DB', '#2874A6']
#colors = ['#A998D9', '#FFA56B', '#FFD56B', '#C0FF6B', '#6BFFD3']
colors = ['purple',  'orange', '#2874A6']
colors = ['#000066',  '#FFB74D', '#2874A6']


# Plot the bars for each asset with the appropriate color
ax.bar(x - bar_width, corr_quintile_plot_aarlig['60/40 vs Commodity futures'], width=bar_width, label='Commodity futures vs 60/40', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x , corr_quintile_plot_aarlig['Stocks vs Bonds'], width=bar_width, label='Stocks vs Bonds', edgecolor='black', linewidth=0.5, color=colors[1])


# Add labels and title
ax.set_xlabel('Quantiles', fontsize=18, fontfamily='Times New Roman')
ax.set_ylabel('Correlation', fontsize=20, fontfamily='Times New Roman')
ax.set_title('Conditional on Yearly Inflation Change', fontsize=24, fontfamily='Times New Roman')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(corr_quintile_plot_aarlig.index, fontsize=16)


# Set the tick labels font
ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})

# Add a legend with Times New Roman font
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size':16})


# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)
import matplotlib.ticker as ticker

# ...

# Set the y-axis ticks and tick labels with Times New Roman font and larger font size
ax.set_yticks(ax.get_yticks())
ax.set_yticklabels(ax.get_yticks(), fontsize=16, fontfamily='Times New Roman')

# Limit the number of decimal places in y-axis tick labels to two
ax.yaxis.set_major_formatter(ticker.FormatStrFormatter('%.2f'))
# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('corr_quantiles_infmean_YEARLYreturn.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()
