
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

# Portfolios
data["60/40"] = data["exequity"]*0.6 + data["exbond"]*0.4
w = 0.235 #fullscale weight of commodity futures index
data["Fullscale"] = (1-w)*(data["exequity"]*0.6 + data["exbond"]*0.4) + (data["exfutucom"])*(w)

#full sample
exReturns = data.iloc[:,[20,21]]


exStats = exReturns.describe()
exStats.loc["mean"] = (exStats.loc["mean"])*12
exStats.loc["std"] = exStats.loc["std"]*np.sqrt(12)
exStats.loc["SR"] = exStats.iloc[1]/exStats.iloc[2]


#before 1945
exReturns1877_1945 = data.iloc[0:826,[20,21]]

exStats1877_1945 = exReturns1877_1945.describe()
exStats1877_1945.loc["mean"] = (exStats1877_1945.loc["mean"])*12
exStats1877_1945.loc["std"] = exStats1877_1945.loc["std"]*np.sqrt(12)
exStats1877_1945.loc["SR"] = exStats1877_1945.iloc[1]/exStats1877_1945.iloc[2]


# post 1945
exReturns1946_2022 = data.iloc[827:,[20,21]]

exStats1946_2022 = exReturns1946_2022.describe()
exStats1946_2022.loc["mean"] = (exStats1946_2022.loc["mean"])*12
exStats1946_2022.loc["std"] = exStats1946_2022.loc["std"]*np.sqrt(12)
exStats1946_2022.loc["SR"] = exStats1946_2022.iloc[1]/exStats1946_2022.iloc[2]



# Descriptive stats for con/backwardation

contango_data = data[data.Stateofbackcon == 1] #contango = 1 
contango_data = contango_data.iloc[:,[20,21]]

backwardation_data = data[data.Stateofbackcon == 0]
backwardation_data = backwardation_data.iloc[:,[20,21]]

stats_con = contango_data.describe()
stats_con.loc["mean"] = (stats_con.loc["mean"])*12
stats_con.loc["std"] = stats_con.loc["std"]*np.sqrt(12)
stats_con.loc["SR"] = stats_con.iloc[1]/stats_con.iloc[2]

stats_back = backwardation_data.describe()
stats_back.loc["mean"] = (stats_back.loc["mean"])*12
stats_back.loc["std"] = stats_back.loc["std"]*np.sqrt(12)
stats_back.loc["SR"] = stats_back.iloc[1]/stats_back.iloc[2]


# Descriptive stats for UNEXPECTED inflation up/down

infup_data = data[data.statinf == 1] 
infup_data = infup_data.iloc[:,[20,21]]

infdown_data = data[data.statinf == 0]
infdown_data = infdown_data.iloc[:,[20,21]]

stats_infup = infup_data.describe()
stats_infup.loc["mean"] = (stats_infup.loc["mean"])*12
stats_infup.loc["std"] = stats_infup.loc["std"]*np.sqrt(12)
stats_infup.loc["SR"] = stats_infup.iloc[1]/stats_infup.iloc[2]


stats_infdown = infdown_data.describe()
stats_infdown.loc["mean"] = (stats_infdown.loc["mean"])*12
stats_infdown.loc["std"] = stats_infdown.loc["std"]*np.sqrt(12)
stats_infdown.loc["SR"] = stats_infdown.iloc[1]/stats_infdown.iloc[2]


# clean tables for all states
exStats = exStats.drop(["count", "min", "25%","50%", "75%", "max"])
exStats1946_2022 = exStats1946_2022.drop(["count", "min", "25%","50%", "75%", "max"])
exStats1877_1945 = exStats1877_1945.drop(["count", "min", "25%","50%", "75%", "max"])

stats_infdown = stats_infdown.drop(["count", "min", "25%","50%", "75%", "max"])
stats_infup = stats_infup.drop(["count", "min", "25%","50%", "75%", "max"])
stats_back = stats_back.drop(["count", "min", "25%","50%", "75%", "max"])
stats_con = stats_con.drop(["count", "min", "25%","50%", "75%", "max"])

# create table

tab = np.matrix(data = np.zeros((6,7)))
#full sample
tab[0,0] = exStats["60/40"][0]
tab[1,0] = exStats["Fullscale"][0]
tab[2,0] = exStats["60/40"][1]
tab[3,0] = exStats["Fullscale"][1]
tab[4,0] = exStats["60/40"][2]
tab[5,0] = exStats["Fullscale"][2]


#pre 1945
tab[0,1] = exStats1877_1945["60/40"][0]
tab[1,1] = exStats1877_1945["Fullscale"][0]
tab[2,1] = exStats1877_1945["60/40"][1]
tab[3,1] = exStats1877_1945["Fullscale"][1]
tab[4,1] = exStats1877_1945["60/40"][2]
tab[5,1] = exStats1877_1945["Fullscale"][2]

#post 1945
tab[0,2] = exStats1946_2022["60/40"][0]
tab[1,2] = exStats1946_2022["Fullscale"][0]
tab[2,2] = exStats1946_2022["60/40"][1]
tab[3,2] = exStats1946_2022["Fullscale"][1]
tab[4,2] = exStats1946_2022["60/40"][2]
tab[5,2] = exStats1946_2022["Fullscale"][2]


#infaltion up
tab[0,3] = stats_infup["60/40"][0]
tab[1,3] = stats_infup["Fullscale"][0]
tab[2,3] = stats_infup["60/40"][1]
tab[3,3] = stats_infup["Fullscale"][1]
tab[4,3] = stats_infup["60/40"][2]
tab[5,3] = stats_infup["Fullscale"][2]

#infaltion down
tab[0,4] = stats_infdown["60/40"][0]
tab[1,4] = stats_infdown["Fullscale"][0]
tab[2,4] = stats_infdown["60/40"][1]
tab[3,4] = stats_infdown["Fullscale"][1]
tab[4,4] = stats_infdown["60/40"][2]
tab[5,4] = stats_infdown["Fullscale"][2]

#backwardation
tab[0,5] = stats_back["60/40"][0]
tab[1,5] = stats_back["Fullscale"][0]
tab[2,5] = stats_back["60/40"][1]
tab[3,5] = stats_back["Fullscale"][1]
tab[4,5] = stats_back["60/40"][2]
tab[5,5] = stats_back["Fullscale"][2]

#contango
tab[0,6] = stats_con["60/40"][0]
tab[1,6] = stats_con["Fullscale"][0]
tab[2,6] = stats_con["60/40"][1]
tab[3,6] = stats_con["Fullscale"][1]
tab[4,6] = stats_con["60/40"][2]
tab[5,6] = stats_con["Fullscale"][2]

tab = pd.DataFrame(data = tab, columns = ["Full Sample", "1877-1945", "1945-2023", "Inflation Up", "Inflation Down", "Backwardation", "Contango"]) 

tab.loc[[4,5]] = tab.loc[[4,5]].round(2)
tab.loc[[0,1,2,3]] = tab.loc[[0,1,2,3]].mul(100).round(1).astype(str).add("%")

tab.rename({0:"60/40",1:"Fullscale portfolio", 2:"60/40", 3:"Fullscale weights", 4:"60/40", 5:"Fullscale weights"}, inplace = True)

tab = tab.reset_index()

print(tab.to_latex(index = False, multirow = True))

